import { jsx as f, jsxs as W } from "react/jsx-runtime";
import G, { useRef as y, useEffect as R, useCallback as J, useState as L, useMemo as K, useId as Q, useReducer as Y, useLayoutEffect as $ } from "react";
import c from "clsx";
const w = "av-text-input", be = "av-text-input-simple", Z = "av-text-input-wrapper", C = "av-text-input-helper-text";
function B() {
  const e = y(!1);
  return R(() => (e.current = !0, () => {
    e.current = !1;
  }), []), J(() => e.current, []);
}
const ee = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function te(e) {
  const r = B(), t = y(0), n = y(null), [l, o] = L(ee), a = K(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((u) => {
    const p = u[0];
    p && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && o(p.contentRect);
    }));
  }), [r]);
  return R(() => (n.current && (a == null || a.observe(n.current, e)), () => {
    a == null || a.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [a, e]), [n, l];
}
function re(e) {
  const r = Q();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const D = "SET_ANNOUNCEMENT", M = "CLEAR_ANNOUNCEMENT", ne = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, le = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case D:
      return {
        ...e,
        announcement: r.payload
      };
    case M:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ae = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: M
  }), typeof e == "function" && e();
}, P = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: l
}) => {
  (t == null ? void 0 : t.current) !== null && clearTimeout(t.current), e !== null && l({
    type: D,
    payload: e
  }), r && (t.current = setTimeout(
    () => ae({
      onAnnouncementClear: n,
      dispatch: l
    }),
    r
  ));
}, ce = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: l,
  onAnnouncementClear: o,
  dispatch: a
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(P, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: o,
    dispatch: a
  }) : P({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: o,
    dispatch: a
  });
};
function oe({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: l,
  clearAnnouncementDelay: o,
  onAnnouncementClear: a,
  visible: u,
  ...p
}) {
  const m = y(), x = y(), [g, s] = Y(le, {
    announcement: null
  });
  let d = t;
  typeof d > "u" && (d = n ? ne[n] : "assertive"), R(() => {
    ce({
      announcementTimeoutRef: m,
      announcementDelay: l,
      children: e,
      clearAnnouncementDelay: o,
      clearAnnouncementTimeoutRef: x,
      onAnnouncementClear: a,
      dispatch: s
    });
  }, [
    e,
    l,
    o,
    a
  ]);
  const i = c(r, {
    "sr-only": !u
  });
  return /* @__PURE__ */ f(
    "div",
    {
      "aria-live": d,
      ...n && { role: n },
      className: i,
      ...p,
      children: g.announcement
    }
  );
}
const se = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
};
/*!
  @versini/ui-private v1.4.18
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.18",
    buildTime: "11/19/2024 10:59 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ue = ({
  mode: e
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), ie = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), pe = ({
  noBorder: e,
  error: r
}) => c("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), de = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n
}) => {
  if (r)
    return "";
  if (e)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-lighter": n === "system",
      "text-copy-lighter dark:text-copy-dark": n === "alt-system"
    });
  if (t)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": n === "system",
      "text-copy-lighter dark:text-copy-error-dark": n === "alt-system"
    });
}, fe = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return c(
      C,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(C, "absolute px-2 font-medium", {
      "text-copy-lighter": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-lighter": t === "system",
      "text-copy-lighter dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return c(C, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": t === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": t === "alt-system"
    });
}, ye = ({
  className: e,
  inputClassName: r,
  raw: t,
  disabled: n,
  noBorder: l,
  error: o,
  spacing: a,
  mode: u,
  focusMode: p,
  size: m,
  rightElementClassName: x
}) => {
  const g = t ? e : c(
    "relative flex w-full flex-col justify-center",
    Z,
    e,
    se(a)
  );
  let s = "";
  switch (m) {
    case "xs":
      s = "h-8";
      break;
    case "sm":
      s = "h-10";
      break;
    case "lg":
      s = "h-14";
      break;
    case "xl":
      s = "h-16";
      break;
    default:
      s = "h-12";
      break;
  }
  const d = t ? c(r) : c(
    w,
    r,
    s,
    "rounded-md text-base px-4",
    ue({ mode: u }),
    ie({ focusMode: p }),
    pe({ noBorder: l, error: o }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": n
    }
  ), i = t ? void 0 : "sr-only", b = de({
    disabled: n,
    raw: t,
    error: o,
    mode: u
  }), E = fe({
    error: o,
    raw: t,
    mode: u,
    disabled: n
  }), I = t ? void 0 : c("absolute right-3", x);
  return {
    wrapper: g,
    input: d,
    accessibleLabel: i,
    visibleLabel: b,
    helperText: E,
    rightElement: I
  };
}, me = G.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: l = !1,
    className: o,
    inputClassName: a,
    mode: u = "system",
    focusMode: p = "system",
    disabled: m = !1,
    noBorder: x = !1,
    labelId: g,
    labelHidden: s = !1,
    type: d = "text",
    helperText: i = "",
    rightElement: b,
    rightElementClassName: E,
    spacing: I,
    size: _ = "md",
    ...U
  }, j) => {
    const [F, T] = te(), [O, X] = L(0), k = re({ id: e, prefix: `${w}-` }), V = `${r} error, ${i}`, A = y(null), v = y(null), q = {
      xs: { label: "-25px", helperText: "30px" },
      sm: { label: "-29px", helperText: "34px" },
      md: { label: "-33px", helperText: "38px" },
      lg: { label: "-15px", helperText: "22px" },
      xl: { label: "-19px", helperText: "25px" }
    }, h = ye({
      className: o,
      inputClassName: a,
      error: n,
      raw: l,
      focusMode: p,
      disabled: m,
      noBorder: x,
      spacing: I,
      mode: u,
      size: _,
      rightElementClassName: E
    });
    return $(() => {
      T && T.width && X(T.width + 18 + 10);
    }, [T]), $(() => {
      var N, S;
      const { label: H, helperText: z } = q[_];
      (N = A == null ? void 0 : A.current) == null || N.style.setProperty("--av-text-input-label", H), (S = v == null ? void 0 : v.current) == null || S.style.setProperty(
        "--av-text-input-helper-text",
        z
      );
    }, [_]), /* @__PURE__ */ W("div", { className: h.wrapper, children: [
      /* @__PURE__ */ f(
        "label",
        {
          htmlFor: k,
          id: g,
          className: h.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ f(
        "input",
        {
          ref: j,
          id: k,
          name: r,
          type: d,
          disabled: m,
          placeholder: l ? void 0 : " ",
          className: h.input,
          ...i && { "aria-describedby": `${k}-helper` },
          ...n && { "aria-invalid": "true" },
          ...b && !l && { style: { paddingRight: O } },
          ...U
        }
      ),
      !l && !s && /* @__PURE__ */ f(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: k,
          className: h.visibleLabel,
          children: t
        }
      ),
      i && /* @__PURE__ */ f(
        "div",
        {
          ref: v,
          id: `${k}-helper`,
          className: h.helperText,
          children: i
        }
      ),
      b && /* @__PURE__ */ f(
        "div",
        {
          ref: F,
          className: h.rightElement,
          children: b
        }
      ),
      n && i && /* @__PURE__ */ f(oe, { politeness: "polite", clearAnnouncementDelay: 500, children: V })
    ] });
  }
);
me.displayName = "TextInput";
export {
  w as TEXT_INPUT_CLASSNAME,
  C as TEXT_INPUT_HELPER_TEXT_CLASSNAME,
  be as TEXT_INPUT_SIMPLE_CLASSNAME,
  Z as TEXT_INPUT_WRAPPER_CLASSNAME,
  me as TextInput,
  oe as j
};
